import sys
from base_sender import *

def test_preprocess_gcodes():
    fp = FakeParent()
    bs = BaseSender(fp, usb_info={1:2})
    print(f"Free mem:{bs.get_free_memory() // 1024 // 1024}")
    if len(sys.argv) > 1:
        filename = sys.argv[1]
    else:
        filename = 'duck.gcode'
    with open(filename, 'rb') as f:
        gcodes = f.read()
        prepro_gcodes = bs.preprocess_gcodes(gcodes)
        print(prepro_gcodes)
        revert_gcodes = b"\n".join(prepro_gcodes) + b"\n"
        assert revert_gcodes == gcodes
        prepro_gcodes = bs.preprocess_gcodes(['a', 'b', 'c', 'd'])
        print(prepro_gcodes)
        assert prepro_gcodes == [b'a', b'b', b'c', b'd']
    print(f"Free mem:{bs.get_free_memory() // 1024 // 1024}")


if __name__ == '__main__':
    test_preprocess_gcodes()
